--freemarker template
<#include "RPTA-Makros"/>
<sqlvars>
<sqlvar name="rpta_installed">
select count(*) from systeminfo where tid=330;
</sqlvar>
</sqlvars>
<#assign rpta_column_layout = 
{"uniquename":"sos_stud_sem",
"caption":"Studierende nach Semester",
"rpta_resultset":"sos_stud_astat",
"whereclause":"",
"description":"Studierende nach Semester"
}
   />

<#assign rpta_columns = [
{"uniquename":"sem_rueck_beur_ein",
"caption":"Semester",
"srcfieldname":"sem_rueck_beur_ein",
"targetfieldname":"sem_rueck_beur_ein",
"column_type":"physicalColumn",
"col_function":"",
"is_visible":"0",
"format_code":"TEXT",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"semester_str",
"caption":"Semester Name",
"srcfieldname":"sem_rueck_beur_ein",
"targetfieldname":"semester_str",
"column_type":"lookupColumn",
"col_function":"select replace(replace(eintrag,''SoSe'',''''),''WiSe '','''') from semester SEM where SEM.tid=sem_rueck_beur_ein",
"is_visible":"1",
"format_code":"",
"visible_size":"5",
"is_aggregate":"0",
"description":""
},
{"uniquename":"summe",
"caption":"Anzahl der Studierenden",
"srcfieldname":"summe",
"column_type":"physicalColumn",
"col_function":"sum",
"is_visible":"1",
"visible_size":"5",
"is_aggregate":"1",
"description":"Summe der Studierenden"
}
]
   />
 
<#if rpta_installed==1>
<@rpta_column_layout_fuellen />
</#if>
